// background.js
console.log('我是后台js...');
//
function util_isnumber(val){
    var regPos = /^[0-9]+.?[0-9]*/; //判断是否是数字。
    if(regPos.test(val) ){
        return true;
    }else{
        return false;
    }
}

function plugin_set_expire(expire,callback){
    chrome.storage.local.set({expire: expire}, callback);
}

function plugin_get_expire(callback){
    chrome.storage.local.get('expire', callback);
}

function util_checkFanpa(str = ''){
    const searchString = "This item is sold out";
    const regex = new RegExp(searchString);
    const containsString = regex.test(str);
    if(containsString){
        return true;
    } else {
        return false;
    }
}

function util_getscript_pageData_content(html=''){
    // 示例HTML代码
    // 正则表达式匹配<script>标签内容的模式
    var scriptTagPattern = /<script\b[^>]*>([\s\S]*?)<\/script>/gm;
    var matches = html.match(scriptTagPattern);
    if (matches) {
        for (var i = 0; i < matches.length; i++) {
            // 提取<script>标签里的内容
            var scriptContent = matches[i].replace(scriptTagPattern, '$1');
            if(scriptContent.indexOf('window.runParams') !=-1){
               return scriptContent;
            }
        }
    }
    return false;
}

function pause_s_time(){
    chrome.storage.local.get(null, function(items) {
        //
        chrome.storage.local.set({pause_s_time: Date.now()});
    });
}

function pause_switch(callback){
    chrome.storage.local.get(null, function(items) {
        //
        let prefix = 'pause';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause: 0}, callback);
            }else{
                chrome.storage.local.set({pause: 1}, callback);
            }
        }
    });
}

function pause_page_switch(callback){
    chrome.storage.local.get(null, function(items) {
        //
        let prefix = 'pause_page';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause_page: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause_page: 0}, callback);
            }else{
                chrome.storage.local.set({pause_page: 1}, callback);
            }
        }
    });
}

function pause_list_switch(callback){
    chrome.storage.local.get(null, function(items) {
        //
        let prefix = 'pause_list';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause_list: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause_list: 0}, callback);
            }else{
                chrome.storage.local.set({pause_list: 1}, callback);
            }
        }
    });
}

function field_name_set(field_name = '', callback){
    chrome.storage.local.set({field_name: field_name}, callback);
}

// Function to convert an image to a Blob
async function imageToBlob(imageUrl) {
  try {
    // Fetch the image as an array buffer
    const response = await fetch(imageUrl);
    const arrayBuffer = await response.arrayBuffer();

    // Create a Blob from the array buffer
    const blob = new Blob([arrayBuffer], { type: response.headers.get("content-type") });

    return blob;
  } catch (error) {
    console.error("Error converting image to Blob:", error);
    return null;
  }
}

// Usage example:
/*const imageUrl = "https://img.kwcdn.com/product/Fancyalgo/VirtualModelMatting/8af63f79afdd388711b1c34289c15cda.jpg?imageView2/2/w/800/q/70/format/webp";
imageToBlob(imageUrl)
  .then(blob => {
    if (blob) {
      // Do something with the Blob, such as uploading it or displaying it
        console.log('aaaa');
        console.log(blob);
    } else {
        console.log("Failed to convert image to Blob.");
    }
  });*/

function urlToBase64(url, callback) {
  const xhr = new XMLHttpRequest();
  xhr.onload = function() {
    const reader = new FileReader();
    reader.onloadend = function() {
      callback(reader.result);
    };
    reader.readAsDataURL(xhr.response);
  };
  xhr.open('GET', url);
  xhr.responseType = 'blob';
  xhr.send();
}

// 使用示例
/*const imageUrl = 'https://example.com/image.jpg'; // 替换为你自己的图片URL
urlToBase64(imageUrl, function(base64String) {
  console.log(base64String); // 这里是Base64编码的图片字符串
});*/
//

function ajax_get(url){
    console.log('url:'+url);
    let _html_result = '';
    var exhibitors_ajax = $.ajax({
             //url: 'https://www.google.com/maps/place/VIP+Wigs+%26+Prosthesis/@37.9009282,-122.0623831,17z/data=!3m1!4b1!4m6!3m5!1s0x808561953bedbbfd:0xe9365860131da46b!8m2!3d37.9009282!4d-122.0623831!16s%2Fg%2F1tcxpx4r?authuser=0&hl=en',
             url:url,
             data: {},
             type: 'GET',
             async:false,
             crossDomain: true,
             //timeout:20000,//20 s
             dataType: 'html',
             contentType:'text/html; charset=utf-8',
             //dataType: 'json',
             //contentType:'application/json;charset=utf-8',
             success: function(data) {
                 _html_result = data;
             },
             error: function(xhr, textStatus, errorThrown) {
                _html_result = 'error';
            }
         });
    return _html_result;
}

function storage_shangjia_about_contact_and_basic_info_set(_shangjia_info={},local_num=1, callback){
    let prefix = 'shangjia_about_contact_and_basic_info_'+$.md5(_shangjia_info['_shangjia_id']);
    //
    chrome.storage.local.get(null, function(items) {
        let total_add_shangjia_num = 0;
        for(let key in items){
            if(key.indexOf('shangjia_about_contact_and_basic_info_') > -1){
                total_add_shangjia_num += 1;
            }
        }
        total_add_shangjia_num = total_add_shangjia_num + local_num;
        //
        //
        if(!items.hasOwnProperty(prefix)){
            let obj = {};
            obj[prefix] = {
                '_shangjia_id': _shangjia_info['_shangjia_id'],
                '_shangjia_name': '',
                //'_shangjia_catalog_1': '',
                //'_shangjia_catalog_2': '',
                '_shangjia_about_contact_and_basic_info_link':_shangjia_info['_shangjia_a_link'],

                '_is_request':0,

                //'_shangjia_img': _shangjia_info['_shangjia_img'],
                //'_shangjia_images': '',
                //'_shangjia_img_blob': '',
                //'_shangjia_price': _shangjia_info['_shangjia_price'],
               // '_shangjia_old_price': _shangjia_info['_shangjia_old_price'],
                //'_shangjia_review_score': _shangjia_info['_shangjia_review_score'],
                //'_shangjia_reivew_num': _shangjia_info['_shangjia_reivew_num'],
                //'_shangjia_sold': _shangjia_info['_shangjia_sold'],
                //'_shangjia_desc':'',

                '_shangjia_store_name': '',
                '_shangjia_store_url': '',
                '_shangjia_store_items': '',
                '_shangjia_store_followers': '',
                '_shangjia_store_sold': '',
                '_shangjia_store_score': '',
                //
                '_shangjia_goodsId':'', //sku
                '_shangjia_variants_skus': [], //数组
                '_shangjia_goodsName': _shangjia_info['_shangjia_name'],
                '_shangjia_goodsProperty':'',//description,deschtml
                '_shangjia_minOnSalePriceStr':'', //最小价格,当没有属性时选择该价格
                '_shangjia_hdThumbUrl': '',//主图
                '_shangjia_gallery':[], //图片列表
                '_shangjia_productDetailFlatList':[],//details imgs
                '_shangjia_category':'',//brumb
                '_shangjia_VideoUrl':'', //video
                '_shangjia_shippingFee':'', //运费

                'num':(total_add_shangjia_num+1)
                //

            };
            chrome.storage.local.set(obj, callback);
        }
        //
    });
    //
}

function storage_shangjia_about_contact_and_basic_info_update_2(need_item, callback){
    let prefix = 'shangjia_about_contact_and_basic_info_'+$.md5(need_item['_shangjia_id']);
    //
    chrome.storage.local.get(null, function(items) {
        //
        if(items.hasOwnProperty(prefix)){
            let obj = {};
            obj[prefix] = {
                '_shangjia_id': need_item['_shangjia_id'],
                '_shangjia_about_contact_and_basic_info_link':need_item['_shangjia_about_contact_and_basic_info_link'],
                '_is_request':2,

                '_shangjia_store_name': need_item['_shangjia_store_name'],
                '_shangjia_store_url': need_item['_shangjia_store_url'],
                '_shangjia_store_items': '',
                '_shangjia_store_followers': '',
                '_shangjia_store_sold': '',
                '_shangjia_store_score': '',
                //
                '_shangjia_goodsId':need_item['_shangjia_goodsId'], //sku
                '_shangjia_variants_skus': need_item['_shangjia_variants_skus'], //数组
                '_shangjia_goodsName': need_item['_shangjia_goodsName'],
                '_shangjia_goodsProperty': need_item['_shangjia_goodsProperty'],//description,deschtml
                '_shangjia_minOnSalePriceStr':need_item['_shangjia_minOnSalePriceStr'], //最小价格,当没有属性时选择该价格
                '_shangjia_hdThumbUrl': need_item['_shangjia_hdThumbUrl'],//主图
                '_shangjia_gallery': need_item['_shangjia_gallery'], //图片列表
                '_shangjia_productDetailFlatList': need_item['_shangjia_productDetailFlatList'],//details imgs
                '_shangjia_category':'',//brumb
                '_shangjia_VideoUrl': need_item['_shangjia_VideoUrl'], //video
                '_shangjia_reivew_num':0,
                '_shangjia_sold':need_item['_shangjia_sold'],
                //
            };
            chrome.storage.local.set(obj, callback);
        }
        //
    });
    //
}

function storage_shangjia_about_contact_and_basic_info_update_request_num(need_item, callback){
    let prefix = 'shangjia_about_contact_and_basic_info_'+$.md5(need_item['_shangjia_id']);
    //
    chrome.storage.local.get(null, function(items) {
        //
        if(items.hasOwnProperty(prefix)){
            let obj = {};
            let _is_request = 0;
            if(need_item['_is_request_num'] == 3){
                _is_request = 2;
            }
            let _is_request_num = 0;
            if(need_item.hasOwnProperty('_is_request_num')){
                _is_request_num = need_item['_is_request_num'];
            }
            obj[prefix] = {
                '_shangjia_id': need_item['_shangjia_id'],
                '_shangjia_about_contact_and_basic_info_link':need_item['_shangjia_about_contact_and_basic_info_link'],
                '_is_request':_is_request,
                '_is_request_num': _is_request_num+1,

                '_shangjia_store_name': need_item['_shangjia_store_name'],
                '_shangjia_store_url': need_item['_shangjia_store_url'],
                '_shangjia_store_items': '',
                '_shangjia_store_followers': '',
                '_shangjia_store_sold': '',
                '_shangjia_store_score': '',
                //
                '_shangjia_goodsId':need_item['_shangjia_goodsId'], //sku
                '_shangjia_variants_skus': need_item['_shangjia_variants_skus'], //数组
                '_shangjia_goodsName': need_item['_shangjia_goodsName'],
                '_shangjia_goodsProperty': need_item['_shangjia_goodsProperty'],//description,deschtml
                '_shangjia_minOnSalePriceStr':need_item['_shangjia_minOnSalePriceStr'], //最小价格,当没有属性时选择该价格
                '_shangjia_hdThumbUrl': need_item['_shangjia_hdThumbUrl'],//主图
                '_shangjia_gallery': need_item['_shangjia_gallery'], //图片列表
                '_shangjia_productDetailFlatList':[],//details imgs
                '_shangjia_category':'',//brumb
                '_shangjia_VideoUrl': need_item['need_item'], //video
                '_shangjia_reivew_num':0,
                '_shangjia_sold':0
                //
            };
            chrome.storage.local.set(obj, callback);
        }
        //
    });
    //
}

function util_get_attr_name_value(productSKUPropertyList=[],_attr_name_id='',_attr_value_id=''){
    let _attr_name = ''
    let _attr_value_name = '';
    let _attr_img = '';
    if(_attr_value_id.indexOf('#')!=-1){
        let _attr_value_id_arr = _attr_value_id.split('#');
        _attr_value_id = _attr_value_id_arr[0];
    }
    for (let i=0;i<productSKUPropertyList.length;i++){
        if(productSKUPropertyList[i]['skuPropertyId'] == _attr_name_id){
            _attr_name = productSKUPropertyList[i]['skuPropertyName'];
            let skuPropertyValues = productSKUPropertyList[i]['skuPropertyValues'];

            for(let j=0;j<skuPropertyValues.length;j++){
                //
                if(_attr_value_id == skuPropertyValues[j]['propertyValueId']){
                    let _skuPropertyValue = skuPropertyValues[j];
                    if(_skuPropertyValue.hasOwnProperty('skuPropertyImagePath')){
                        _attr_img = skuPropertyValues[j]['skuPropertyImagePath'];
                    }
                    _attr_value_name = skuPropertyValues[j]['propertyValueName'];
                    break;
                }
                //
            }
            break;
        }
    }
    return {
        '_attr_name':_attr_name,
        '_attr_value_name':_attr_value_name,
        '_attr_img':_attr_img
    }
}

function request_shangjia_about_contact_and_basic_info_ajax(storage_key=''){
    chrome.storage.local.get(null, function(items) {
        let need_item = items[storage_key];
        //
        //need_item['_shangjia_about_contact_and_basic_info_link'] = 'https://www.temu.com/goods.html?_bg_fs=1&goods_id=601099513966458';
        /*(if(need_item['_shangjia_about_contact_and_basic_info_link']){
            need_item['_e_time'] = Date.now();
            need_item['_is_request'] = 2;
            let obj = {};
            obj[storage_key] = need_item;
            chrome.storage.local.set(obj, function (){
            });
            return;
        }*/
        console.log('request_shangjia_about_contact_and_basic_info_ajax aaa');
        console.log(need_item['_shangjia_about_contact_and_basic_info_link']);
        //
        $.ajax({
            url:need_item['_shangjia_about_contact_and_basic_info_link'],
            timeout : 30000, //超时时间设置，单位毫秒
            data: {},
            type: 'GET',
            async:true,
            dataType: 'html',
            contentType:'text/html; charset=utf-8',
            crossDomain: true,
            cache: false,
            success: function(data) {
                console.log('data');
                //console.log(data);
               let _dom = $(data);
               //
               let _mainContent = _dom.find('.mainContent').text();
               let _baseContent = _dom.find('.baseContent').text();
               let _checkContent = _mainContent;
               if(_baseContent){
                   _checkContent += _baseContent;
               }
               if(false && util_checkFanpa(_checkContent)){
                   console.log('util_checkFanpa a1');
                   //
                    need_item['_is_request'] = 0;
                    need_item['_error'] = '遇到反爬,请开启或者更换代理或者暂停采集，稍后再采集!';
                    let obj = {};
                    obj[storage_key] = need_item;
                    chrome.storage.local.set(obj, function (){
                            //

                            //
                    });
                    pause_s_time();
                    sendPopTips("遇到反爬,请开启或者更换代理或者暂停采集，稍后再采集!", need_item['_shangjia_about_contact_and_basic_info_link']);
                    //
               }else{
                   //console.log('util_checkFanpa a2');
                   //
                   let runParamscript = util_getscript_pageData_content(data);
                   console.log('runParamscript a1');
                   if(runParamscript){
                        runParamscript = runParamscript.trim();
                        runParamscript = runParamscript.replace('window.runParams =','')
                            .replace('window.runParams.is23 = true;','');
                        runParamscript = runParamscript.trim();
                        runParamscript = runParamscript.slice(0, -1);
                        //
                        let runParamscript_arr = runParamscript.split('data:');
                        runParamscript = runParamscript_arr[1];
                        runParamscript = runParamscript.slice(0, -1);
                        runParamscript = runParamscript.trim();
                        //
                        console.log('runParamscript');
                       //console.log(runParamscript);
                        let runParamscript_json = JSON.parse(runParamscript);
                        console.log(runParamscript_json);
                        //
                       if(runParamscript_json){
                            //
                            let _skus = runParamscript_json['priceComponent']['skuPriceList'];
                            let _item = runParamscript_json['productInfoComponent'];
                            let _shangjia_variants_skus = [];
                            if(_skus && _skus.length > 0){
                                //
                                let _productSKUPropertyList = runParamscript_json['skuComponent']['productSKUPropertyList'];
                                //
                                for(let _i=0;_i<_skus.length;_i++){
                                    //
                                    let specs_key1_name = '';
                                    let specs_key1_value = '';
                                    let specs_key2_name = '';
                                    let specs_key2_value = '';
                                    let specs_key3_name = '';
                                    let specs_key3_value = '';
                                    let specs_key4_name = '';
                                    let specs_key4_value = '';
                                    let _attr_img = '';
                                    //
                                    let skuAttr = _skus[_i]['skuAttr'];
                                    let skuAttrArr = skuAttr.split(';');
                                    if(skuAttrArr.length == 1){
                                        let _attr_value = skuAttrArr[0];
                                        let _attr_value_arr = _attr_value.split(':');
                                        let _attr_name_id = _attr_value_arr[0];
                                        let _attr_value_id = _attr_value_arr[1];
                                        let attr_name_value_arr = util_get_attr_name_value(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                        specs_key1_name = attr_name_value_arr['_attr_name'];
                                        specs_key1_value = attr_name_value_arr['_attr_value_name'];
                                        if(_attr_img == '' && attr_name_value_arr['_attr_img']){
                                            _attr_img = attr_name_value_arr['_attr_img'];
                                        }
                                    }else if(skuAttrArr.length == 2){
                                        let _attr_value = skuAttrArr[0];
                                        let _attr_value_arr = _attr_value.split(':');
                                        let _attr_name_id = _attr_value_arr[0];
                                        let _attr_value_id = _attr_value_arr[1];
                                        let attr_name_value_arr = util_get_attr_name_value(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                        specs_key1_name = attr_name_value_arr['_attr_name'];
                                        specs_key1_value = attr_name_value_arr['_attr_value_name'];
                                        if(_attr_img == '' && attr_name_value_arr['_attr_img']){
                                            _attr_img = attr_name_value_arr['_attr_img'];
                                        }
                                        //
                                        _attr_value = skuAttrArr[1];
                                        _attr_value_arr = _attr_value.split(':');
                                        _attr_name_id = _attr_value_arr[0];
                                        _attr_value_id = _attr_value_arr[1];
                                        attr_name_value_arr = util_get_attr_name_value(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                        specs_key2_name = attr_name_value_arr['_attr_name'];
                                        specs_key2_value = attr_name_value_arr['_attr_value_name'];
                                        if(_attr_img == '' && attr_name_value_arr['_attr_img']){
                                            _attr_img = attr_name_value_arr['_attr_img'];
                                        }
                                        //
                                    }else if(skuAttrArr.length == 3){
                                        let _attr_value = skuAttrArr[0];
                                        let _attr_value_arr = _attr_value.split(':');
                                        let _attr_name_id = _attr_value_arr[0];
                                        let _attr_value_id = _attr_value_arr[1];
                                        let attr_name_value_arr = util_get_attr_name_value(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                        specs_key1_name = attr_name_value_arr['_attr_name'];
                                        specs_key1_value = attr_name_value_arr['_attr_value_name'];
                                        if(_attr_img == '' && attr_name_value_arr['_attr_img']){
                                            _attr_img = attr_name_value_arr['_attr_img'];
                                        }
                                        //
                                        _attr_value = skuAttrArr[1];
                                        _attr_value_arr = _attr_value.split(':');
                                        _attr_name_id = _attr_value_arr[0];
                                        _attr_value_id = _attr_value_arr[1];
                                        attr_name_value_arr = util_get_attr_name_value(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                        specs_key2_name = attr_name_value_arr['_attr_name'];
                                        specs_key2_value = attr_name_value_arr['_attr_value_name'];
                                        if(_attr_img == '' && attr_name_value_arr['_attr_img']){
                                            _attr_img = attr_name_value_arr['_attr_img'];
                                        }
                                        //
                                        _attr_value = skuAttrArr[2];
                                        _attr_value_arr = _attr_value.split(':');
                                        _attr_name_id = _attr_value_arr[0];
                                        _attr_value_id = _attr_value_arr[1];
                                        attr_name_value_arr = util_get_attr_name_value(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                        specs_key3_name = attr_name_value_arr['_attr_name'];
                                        specs_key3_value = attr_name_value_arr['_attr_value_name'];
                                        if(_attr_img == '' && attr_name_value_arr['_attr_img']){
                                            _attr_img = attr_name_value_arr['_attr_img'];
                                        }
                                        //
                                    }else if(skuAttrArr.length == 4){
                                        let _attr_value = skuAttrArr[0];
                                        let _attr_value_arr = _attr_value.split(':');
                                        let _attr_name_id = _attr_value_arr[0];
                                        let _attr_value_id = _attr_value_arr[1];
                                        let attr_name_value_arr = util_get_attr_name_value(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                        specs_key1_name = attr_name_value_arr['_attr_name'];
                                        specs_key1_value = attr_name_value_arr['_attr_value_name'];
                                        if(_attr_img == '' && attr_name_value_arr['_attr_img']){
                                            _attr_img = attr_name_value_arr['_attr_img'];
                                        }
                                        //
                                        _attr_value = skuAttrArr[1];
                                        _attr_value_arr = _attr_value.split(':');
                                        _attr_name_id = _attr_value_arr[0];
                                        _attr_value_id = _attr_value_arr[1];
                                        attr_name_value_arr = util_get_attr_name_value(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                        specs_key2_name = attr_name_value_arr['_attr_name'];
                                        specs_key2_value = attr_name_value_arr['_attr_value_name'];
                                        if(_attr_img == '' && attr_name_value_arr['_attr_img']){
                                            _attr_img = attr_name_value_arr['_attr_img'];
                                        }
                                        //
                                        _attr_value = skuAttrArr[2];
                                        _attr_value_arr = _attr_value.split(':');
                                        _attr_name_id = _attr_value_arr[0];
                                        _attr_value_id = _attr_value_arr[1];
                                        attr_name_value_arr = util_get_attr_name_value(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                        specs_key3_name = attr_name_value_arr['_attr_name'];
                                        specs_key3_value = attr_name_value_arr['_attr_value_name'];
                                        if(_attr_img == '' && attr_name_value_arr['_attr_img']){
                                            _attr_img = attr_name_value_arr['_attr_img'];
                                        }
                                        //
                                        _attr_value = skuAttrArr[3];
                                        _attr_value_arr = _attr_value.split(':');
                                        _attr_name_id = _attr_value_arr[0];
                                        _attr_value_id = _attr_value_arr[1];
                                        attr_name_value_arr = util_get_attr_name_value(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                        specs_key4_name = attr_name_value_arr['_attr_name'];
                                        specs_key4_value = attr_name_value_arr['_attr_value_name'];
                                        if(_attr_img == '' && attr_name_value_arr['_attr_img']){
                                            _attr_img = attr_name_value_arr['_attr_img'];
                                        }
                                        //
                                    }
                                    //
                                    let _skuVal = _skus[_i]['skuVal'];
                                    let normalPriceStr = _skus[_i]['skuVal']['skuAmount']['formatedAmount'];
                                    if(_skuVal.hasOwnProperty('skuActivityAmount')){
                                        normalPriceStr = _skus[_i]['skuVal']['skuActivityAmount']['formatedAmount'];
                                    }
                                    //
                                    _shangjia_variants_skus.push({
                                        'subsku': _item['id']+specs_key1_value+specs_key2_value+specs_key3_value+specs_key4_value,
                                        'normalPriceStr': normalPriceStr,
                                        'normalLinePriceStr':_skus[_i]['skuVal']['skuAmount']['formatedAmount'],
                                        'img':_attr_img,
                                        'specs_key1_name':specs_key1_name,
                                        'specs_key1_value':specs_key1_value,
                                        'specs_key2_name':specs_key2_name,
                                        'specs_key2_value':specs_key2_value,
                                        'specs_key3_name':specs_key3_name,
                                        'specs_key3_value':specs_key3_value,
                                        'specs_key4_name':specs_key4_name,
                                        'specs_key4_value':specs_key4_value,
                                        'stockQuantity': _skus[_i]['skuVal']['inventory'],
                                        'skuId': _skus[_i]['skuId']
                                    });
                                    //
                                }
                            }
                            need_item['_shangjia_variants_skus'] = _shangjia_variants_skus;
                            //
                            need_item['_shangjia_goodsId'] = _item['id'];
                            need_item['_shangjia_goodsName'] = _item['subject'];
                            need_item['_shangjia_minOnSalePriceStr'] = _item['minPrice'];
                            //
                            let _shangjia_VideoUrl = '';
                            let _shangjia_gallery = runParamscript_json['imageComponent']['imagePathList'];
                            need_item['_shangjia_gallery'] = _shangjia_gallery;
                            if(_shangjia_gallery.length > 0){
                                need_item['_shangjia_hdThumbUrl'] = _shangjia_gallery[0];
                            }
                            need_item['_shangjia_VideoUrl'] = _shangjia_VideoUrl;
                           //
                           need_item['_shangjia_category'] = '';
                           need_item['_shangjia_sold'] = runParamscript_json['tradeComponent']['formatTradeCount'];
                           need_item['_shangjia_reivew_num'] = runParamscript_json['feedbackComponent']['totalValidNum'];
                           need_item['_shangjia_shippingFee'] = runParamscript_json['webGeneralFreightCalculateComponent']['shippingFeeText'];
                           //
                           let sellerComponent = runParamscript_json['sellerComponent'];
                           let storeURL = sellerComponent['storeURL'];
                           storeURL = storeURL.replace('//','https');
                           need_item['_shangjia_store_name'] = sellerComponent['storeName'];
                           need_item['_shangjia_store_url'] = storeURL;
                           need_item['_shangjia_store_items'] = '';
                           need_item['_shangjia_store_followers'] = '';
                           need_item['_shangjia_store_sold'] = '';
                           need_item['_shangjia_store_score'] = '';
                           need_item['_shangjia_store_country'] = sellerComponent['countryCompleteName'];
                           need_item['_shangjia_store_opentime'] = sellerComponent['formatOpenTime'];
                           //
                           let descriptionUrl =  runParamscript_json['productDescComponent']['descriptionUrl'];
                           let description_data = ajax_get(descriptionUrl);
                           console.log('description_data');
                           console.log(description_data);
                           if(description_data){
                                description_data = '<div>'+description_data+'</div>';
                                description_data = description_data.replaceAll('(','');
                                description_data = description_data.replaceAll(')','');
                                let _description_data_dom = $(description_data);
                                let _shangjia_productDetailFlatList = [];
                                _description_data_dom.find('img').each(function () {
                                    _shangjia_productDetailFlatList.push($(this).attr('src'));
                                })
                                need_item['_shangjia_productDetailFlatList'] = _shangjia_productDetailFlatList;
                                //
                                need_item['_shangjia_goodsProperty'] = description_data.replace(/<a\s+href="[^"]*"/g, '<a href="#"');
                                //
                           }
                           need_item['_is_request'] = 2;
                           //
                       }else{
                           console.log('scriptdata_json error');
                           need_item['_is_request'] = 0;
                           need_item['_error'] = '';
                           pause_s_time();
                           sendPopTips("遇到反爬,请验证或者更换代理或者暂停采集稍后再采集!", need_item['_shangjia_about_contact_and_basic_info_link']);
                            //
                       }
                       //
                   }else{
                       console.log('scriptdata_json error');
                       need_item['_is_request'] = 0;
                       need_item['_error'] = '';
                       pause_s_time();
                       sendPopTips("遇到反爬,请验证或者更换代理或者暂停采集稍后再采集!", need_item['_shangjia_about_contact_and_basic_info_link']);
                        //
                   }
                   //
                   need_item['_e_time'] = Date.now();
                   console.log('need_item');
                   console.log(need_item);
                   let obj = {};
                   obj[storage_key] = need_item;
                   chrome.storage.local.set(obj, function (){
                   });
                   //
               }
            },
            error: function( jqXHR, textStatus, errorThrown ) {
                console.log('ajax error');
                console.log( jqXHR, textStatus, errorThrown );
                //
                need_item['_is_request'] = 0;
                need_item['_error'] = errorThrown;
                let obj = {};
                obj[storage_key] = need_item;
                chrome.storage.local.set(obj, function (){
                        //

                        //
                });
                //
                pause_s_time();
                sendPopTips("遇到反爬,请验证或者更换代理或者暂停采集，稍后再采集!", need_item['_shangjia_about_contact_and_basic_info_link']);
                //
            }
        });
        //
    })
}

function request_shangjia_about_contact_and_basic_info(){
    chrome.storage.local.get(null, function(items) {
        //
        let need_item = null;
        for(let key in items){
            if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                if(items[key]['_is_request'] == 0 || (items[key]['_is_request'] == 1 && items[key]['_s_time'] < (Date.now()-50000))){
                    need_item = items[key];
                    if(need_item['_shangjia_about_contact_and_basic_info_link']){
                        need_item['_is_request'] = 1;
                        need_item['_s_time'] = Date.now();
                        let obj = {};
                        obj[key] = need_item;
                        chrome.storage.local.set(obj, function (){
                                //
                            request_shangjia_about_contact_and_basic_info_ajax(key);
                                //
                        });
                        break;
                    }
                }
            }
        }
        //
    });
}

function xintiao(){
     chrome.storage.local.get(null, function(items) {
         if(!items.hasOwnProperty('pause') || items['pause'] == 0){
             if( false && items.hasOwnProperty('pause_s_time')  && (items['pause_s_time']+360000) > Date.now()){
                console.log('爬取失败，暂停360s');
             }else{
                 console.log('爬取中');
                 request_shangjia_about_contact_and_basic_info();
             }
         }else{
             console.log('已暂停爬取');
         }
    });

    //request_shangjia_about_work_and_education_link();
    //request_shangjia_company_page_link();
    chrome.storage.local.get(null, function(items) {
        console.log('items');
        console.log(items);
    });
    //let str = '';

    //let _dom = $(str);
    //https://www.facebook.com/gabriella.obi.77/about_work_and_education
    //
    //let _shangjia_company_page_link = _dom.find('.x1gan7if span.xvq8zen a.x1a2a7pz.xt0b8zv').attr('href');
    //console.log(_shangjia_company_page_link);

    //let _shangjia_company_page_name = _dom.find('.x1gan7if span.xvq8zen a.x1a2a7pz.xt0b8zv').text();
    //console.log(_shangjia_company_page_name);
}
xintiao();
setInterval(xintiao, 20000);

function storage_clear(){
    /*plugin_get_expire(function (callback_data){
        let expire_date = callback_data['expire'];
        if(typeof expire_date != 'undefined'){
            chrome.storage.local.clear(function(){
                console.log('remove all');
                plugin_set_expire(expire_date);
            })
        }else{
            chrome.storage.local.clear(function(){
                console.log('remove all');
            })
        }
    });*/
    chrome.storage.local.get(null, function(items) {
        //
        let need_item = null;
        for (let key in items) {
            if (key.indexOf('shangjia_about_contact_and_basic_info_') != -1) {
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
            if (key.indexOf('shangjia_about_work_and_education_') != -1) {
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
            if(key == 'shangjias'){
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
        }
    });
}
//
function get_data_process(){

    let total_add_shangjia_num = 0;
    let has_caiji_geren_num = 0;
    let has_caiji_company_num = 0;

    chrome.storage.local.get(null, function(items) {
        //
        for(let key in items){
            if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                total_add_shangjia_num += 1;
                if(items[key]['_is_request'] == 2){
                    has_caiji_geren_num += 1;
                }
            }

        }
        //
        let obj = {};
        obj['data_process'] = {
            'total_add_shangjia_num': total_add_shangjia_num,
            'has_caiji_geren_num': has_caiji_geren_num,
            'has_caiji_company_num': has_caiji_company_num,
        }
        chrome.storage.local.set(obj, function (){
            //
            //
        });
        //
    });
}
//
function data_process_get(callback){
     /*chrome.storage.sync.get('domains', (res) => {
        console.log(res);
        return res;
     });*/
    chrome.storage.local.get('data_process', callback);
}

function storage_shangjias_update(shangjia_infos=[]){
    //console.log('storage_shangjias_update a');
    chrome.storage.local.get('shangjias', function(items) {
        //console.log('storage_shangjias_update b');
        //console.log(items);
        if(!items.hasOwnProperty('shangjias')){
            let obj = {};
            let shangjias = [];
            for(let i=0;i<shangjia_infos.length;i++){
                shangjias.push(shangjia_infos[i]['_shangjia_id']);
            }
            obj['shangjias'] = shangjias;
            chrome.storage.local.set(obj);
        }else{
            let storage_shangjias = items['shangjias'];

            for(let i=0;i<shangjia_infos.length;i++){
                let is_exists = false;
                for(let j=0;j<storage_shangjias.length;j++){
                    if(shangjia_infos[i]['_shangjia_id'] == storage_shangjias[j]){
                        is_exists = true;
                        break;
                    }
                }
                //
                if(!is_exists){
                    storage_shangjias.push(shangjia_infos[i]['_shangjia_id']);
                }
                //
            }
            //
            let obj = {};
            obj['shangjias'] = storage_shangjias;
            chrome.storage.local.set(obj);
            //
        }
    })
}

function storage_get(callback){
    chrome.storage.local.get(null, callback);
}

//监听扩展程序进程或内容脚本发送请求的请求
chrome.runtime.onMessage.addListener(
  function (request, sender, sendResponse) {
    if (request.action == 'shangjia_items_update') {
        console.log('action',request,sender,sendResponse);
        //
        let shangjia_infos = request.shangjia_infos;
        //
        //storage_shangjias_update(shangjia_infos);
        //
        for (let i=0;i<shangjia_infos.length;i++){
            storage_shangjia_about_contact_and_basic_info_set(shangjia_infos[i],(i+1), function (){

            });
        }
        //
        //request {action: "send", keyword: "keyword value"}
        //sender  {id: "agkllkkjbhclhjnlebdbdagkagfgcecj", url: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj/popup.html", origin: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj"}
        //sendResponse  ƒ () { [native code] }
        sendResponse({state:'关键词填写成功！'});
    }else if(request.action  == 'can_zidong_caiji'){
        console.log('can_zidong_caiji',request,sender,sendResponse);
        //判断，如果加入超过5000个，则不能，而且需要已开启自动采集
        chrome.storage.local.get(null, function(items) {
            if(!items.hasOwnProperty('pause_page') || items['pause_page'] == 0){
                //已开启
                let total_add_shangjia_num = 0;
                for(let key in items){
                    if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                        total_add_shangjia_num += 1;
                    }
                }
                if(total_add_shangjia_num < 5000){
                    sendResponse(JSON.stringify({state:0}));
                }else{
                    sendResponse(JSON.stringify({state:1}));
                }
                //
            }else{
                //已关闭
                sendResponse(JSON.stringify({state:1}));
            }
        });
        //
        return true;
    }else if(request.action  == 'caiji_item_get_taobao'){
        console.log('caiji_item_get_taobao');
        //
        chrome.storage.local.get(null, function(items) {
            let need_item = null;
            let status = 0;
            if(!items.hasOwnProperty('pause') || items['pause'] == 0){
                 for(let key in items){
                    if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                        if(items[key]['_is_request'] == 0){
                            need_item = items[key];
                            let _shangjia_about_contact_and_basic_info_link = need_item['_shangjia_about_contact_and_basic_info_link'];
                            if(_shangjia_about_contact_and_basic_info_link && _shangjia_about_contact_and_basic_info_link.indexOf('taobao') !=-1){
                                break;
                            }else{
                                need_item = null;
                            }
                        }
                    }
                }
            }else{
                console.log('已暂停爬取');
                status = 1;
            }

            if(need_item){
                //
                //storage_shangjia_about_contact_and_basic_info_update_request_num(need_item);
                //
                sendResponse(JSON.stringify({need_item:need_item,'status':0}));
            }else{
                if(status==0){
                    sendResponse(JSON.stringify({need_item:'','status':2}));
                }else{
                    sendResponse(JSON.stringify({need_item:'','status':1}));
                }
            }
        });
        return true;
        //
    }else if(request.action  == 'caiji_item_get_tmall'){
        console.log('caiji_item_get_tmall');
        //
        chrome.storage.local.get(null, function(items) {
            let need_item = null;
            let status = 0;
            if(!items.hasOwnProperty('pause') || items['pause'] == 0){
                 for(let key in items){
                    if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                        if(items[key]['_is_request'] == 0){
                            need_item = items[key];
                            let _shangjia_about_contact_and_basic_info_link = need_item['_shangjia_about_contact_and_basic_info_link'];
                            if(_shangjia_about_contact_and_basic_info_link){
                                break;
                            }else{
                                need_item = null;
                            }
                        }
                    }
                }
            }else{
                console.log('已暂停爬取');
                status = 1;
            }

            if(need_item){
                //
                //storage_shangjia_about_contact_and_basic_info_update_request_num(need_item);
                //
                sendResponse(JSON.stringify({need_item:need_item,'status':0}));
            }else{
                if(status==0){
                    sendResponse(JSON.stringify({need_item:'','status':2}));
                }else{
                    sendResponse(JSON.stringify({need_item:'','status':1}));
                }
            }
        });
        return true;
        //
    }else if(request.action  == 'caiji_item_update'){
        //
        let need_item = request.need_item;
        storage_shangjia_about_contact_and_basic_info_update_2(need_item, function (){
            sendResponse(JSON.stringify({state:1}));
        });
        return true;
        //
    }else if(request.action  == 'can_list_caiji'){
        console.log('can_list_caiji',request,sender,sendResponse);
        //判断，如果加入超过5000个，则不能，而且需要已开启自动采集
        chrome.storage.local.get(null, function(items) {
            if(!items.hasOwnProperty('pause_list') || items['pause_list'] == 0){
                //已开启
                let total_add_shangjia_num = 0;
                for(let key in items){
                    if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                        total_add_shangjia_num += 1;
                    }
                }
                if(total_add_shangjia_num < 5000){
                    sendResponse(JSON.stringify({state:0}));
                }else{
                    sendResponse(JSON.stringify({state:1}));
                }
                //
            }else{
                //已关闭
                sendResponse(JSON.stringify({state:1}));
            }
        });
        //
        return true;
    }else if(request.action  == 'get_description'){
         let url = request.url;
         let description_data = ajax_get(url);
         sendResponse(JSON.stringify({description:description_data}));
         return true;
    }
  }
);

/**
 * 1.
 * chrome.runtime.onInstalled.addListener(details => {
  console.log('previousVersion', details.previousVersion);
});
2.
 //发送消息
 chrome.runtime.sendMessage({
        action: 'send',
        keyword: 'keyword value'
      }, function (response) {   //接收回调
        console.log(response);  //{state:'关键词填写成功！'}
      });

//监听扩展程序进程或内容脚本发送请求的请求
chrome.runtime.onMessage.addListener(
  function (request, sender, sendResponse) {
    if (request.action == 'send') {
      console.log('action',request,sender,sendResponse);
//  request {action: "send", keyword: "keyword value"}
 //sender  {id: "agkllkkjbhclhjnlebdbdagkagfgcecj", url: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj/popup.html", origin: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj"}
//sendResponse  ƒ () { [native code] }
      sendResponse({state:'关键词填写成功！'});
    }
  }
);
 */

function sendPopTips(msg = '', url=''){
     chrome.runtime.sendMessage({
        action: 'background-tips',
        info: msg,
         url:url,
      }, function (response) {   //接收回调
        console.log(response);  //{state:'关键词填写成功！'}
      });
}